clear all;
close all; 

%Hurst parameter
H = 0.25;

% mesh size 
T = 1;
h = 1000; t = 1/h : 1/h : T;
n = length(t);

%mu
mu = zeros(n,1);


%Make the covariance matrix
Sigma = zeros(n,n);
for i = 1:n
    for j = 1:n
         Sigma(i,j) = 1/2 * (t(i)^(2*H) + t(j)^(2*H)...
               - (abs(t(i) - t(j)))^(2 * H));
    end
end

X(1) = 1/1000;
X(2) = 1/500; 
X(3) = 3/1000; 


t_new = 4/h : 1/h : T;
n_new = length(t_new);

X1 = [X(1); X(2); X(3)];
Sigma11 = Sigma(1:3, 1:3);
Sigma21 = Sigma(4:end, 1:3);
Sigma12 = Sigma(1:3, 4:end);
Sigma22 = Sigma(4:end, 4:end);

% conditional mu
mu_new = mu(4:end) + Sigma21 * inv(Sigma11) * (X1 - mu(1:3));

% conditional cov
Sigma_new = Sigma22 - Sigma21 * inv(Sigma11) * Sigma12;

%Generate the multivariate normal vector
A = chol(Sigma_new)';
X = [X1; mu_new + A*randn(n-3,1)];

%Plot
t = [0,t];
X = [0;X];
plot(t,X);         
hold on; 
plot(t_new, mu_new, 'green');