clear all;
close all;

%use mesh size h
T = 1; 
h = 1000; 
t = 1/h : 1/h : T;
n = length(t);
sigma = 1;

% Simulating Brownian motion
%Make the mean vector
mu = zeros(1,n);
for i = 1:n
    mu(i) = 0;
end

%Make the covariance matrix
Sigma = zeros(n,n);
for i = 1:n
    for j = 1:n
        Sigma(i,j) = min(t(i),t(j));
    end
end

%Generate the multivariate normal vector
A = chol(Sigma);
W = mu + randn(1,n) * A;

%Plot
X = exp(-(0.5 * sigma^2) .* t + sigma * W);
plot(t,X);